﻿using Kendo.Mvc.UI;
using Kendo.Mvc.Extensions;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.IO;

namespace TelerikMvcApp1.Controllers
{
    public class HomeController : Controller
    {
        public ActionResult Index()
        {
            ViewBag.Message = "Welcome to ASP.NET MVC!";

            return View();
        }

        public ActionResult ReadDirectory(string path)
        {
            var root = Server.MapPath("/");
            var directory = path;

            if (directory == null)
            {
                directory = root;
            }
            else
            {
                directory = Path.Combine(root, path);
            }

            var info = new DirectoryInfo(directory);

            if (!info.FullName.StartsWith(root, StringComparison.OrdinalIgnoreCase))
            {
                throw new HttpException(403, "Access denied");
            }

            var entries = new DirectoryInfo(directory)
                                   .EnumerateFileSystemInfos()
                                   .Select(entry => new
                                   {
                                       Path = path != null ? Path.Combine(path, entry.Name) : entry.Name,
                                       Name = entry.Name,
                                       HasChildren = entry is DirectoryInfo
                                   });

            

            return Json(entries, JsonRequestBehavior.AllowGet);
        }
    }
}
